clc;
disp('Wavelet-based Video Watermarking');
disp('In order to obtain source code please visit');
disp(' ');
disp('http://www.advancedsourcecode.com/wavevideowater.asp');
disp(' ');
disp('Luigi Rosa');
disp('email: luigi.rosa@tiscali.it');
disp('mobile: +39 3207214179');
disp(' ');
disp('Please wait...');
disp(' ');
pause(5);

% Read input video
[namefile,pathname]=uigetfile('*.*','Select AVI video');
if namefile~=0
    video_file_name = sprintf('%s%s',pathname,namefile);
    disp('Input file has been selected.');    
else
    error('No valid file has been selected.');
end
mov             = aviread(video_file_name);
fileinfo        = aviinfo(video_file_name);

% Read input watermark (a logical watermark)
[namefile,pathname]=uigetfile('*.*','Select watermark (logical image)');
if namefile~=0
    watermark_file = sprintf('%s%s',pathname,namefile);
    disp('Input file has been selected.');    
else
    error('No valid file has been selected.');
end
watermak_image  = imread(watermark_file);
watermak_image  = im2bw(watermak_image);

% Create watermarked video 
[watermarked_video,watermarkingdata] = videowatermark(mov,watermak_image);

% Create movie with given frames (save frames to .avi file)
watermarked_video_file_name = 'watermarked_video.avi';
create_video(watermarked_video_file_name,watermarked_video,fileinfo);

% Watermark detection
watermarked_mov       = aviread(watermarked_video_file_name);
[recovered_watermark] = watermarkdetection(watermarked_mov,watermarkingdata);

% Watermark visualization
figure,
subplot(1,2,1),imshow(watermak_image),title('Original watermark'),
subplot(1,2,2),imshow(recovered_watermark),title('Recovered watermark');

% Printed messages
mymessage = sprintf('%s%s','Original video: ',video_file_name);
disp(mymessage);
mymessage = sprintf('%s%s','Watermark: ',watermark_file);
disp(mymessage);
mymessage = sprintf('%s%s','Watermarked video: ',watermarked_video_file_name);
disp(mymessage);


